import _WidgetBase = require("./_WidgetBase");

declare module "./_WidgetBase" {
    interface _WidgetBase {

        /**
         * Gets the right direction of text.
         */
        getTextDir(text: string): string;

        /**
         * Set element.dir according to this.textDir, assuming this.textDir has a value.
         */
        applyTextDir(element: HTMLElement, text?: string): void;

        /**
         * Wraps by UCC (Unicode control characters) option's text according to this.textDir
         */
        enforceTextDirWithUcc(option: HTMLOptionElement, text: string): string;

        /**
         * Restores the text of origObj, if needed, after enforceTextDirWithUcc, e.g. set("textDir", textDir).
         */
        restoreOriginalText(origObj: HTMLOptionElement): HTMLOptionElement;
    }
}

export = _WidgetBase;
